Unit PRG;

Interface

uses
 FDOS,Data,Dialogs,Keyboard;

Procedure LoadPRG(Filename:string);

Implementation

Var
 Handle:word;
 Size  :word;
 Offset:word;

Procedure LoadPRG(Filename:string);
 begin
  Handle:=OpenFile(FileName,fmRead);
  if Handle=0 then begin
   StatusBar(FileName+' not found');
   GetKey;
  end else begin
   Size:=FileSize(Handle)-2;
   if FileName[Length(FileName)]='0' then begin { .P00 else .PRG }
    SeekFile(Handle,$1A);
    Dec(Size,$1A);
   end;
   ReadFile(Handle,Offset,2);
   ReadFile(Handle,Mem[RAMSeg:Offset],Size);
   CloseFile(Handle);

   Inc(Size,Offset);

   MemW[RAMSeg:$2B]:=Offset; { Start of BASIC Text Area ($0801) }
   MemW[RAMSeg:$2D]:=Size;   { Start of BASIC Variables }
   MemW[RAMSeg:$2F]:=Size;   { Start of BASIC Arrays    }
   MemW[RAMSeg:$31]:=Size+1; { End of BASIC Arrays +1   }
  end;
 end;

end.