Program Tweak;

Const
 CharWidth   = 8;

 VideoWidth  = 816; { virtual pixels }
 VideoHeight = 525; { virtual pixels }

 ScreenWidth = 712; { visible pixels }
 RightBorder = 720; { End of Visible Line < VideoWidth }

 HorzStart   = 10;  { End   Horz. Retrace }
 HorzRetrace = 752; { Start Horz. Retrace }


 CRTC:array[0..17] of word=(
  $00 + ((VideoWidth div CharWidth)+5) shl 8,
  $01 + (ScreenWidth div CharWidth) shl 8,
  $02 + (RightBorder div CharWidth) shl 8,
  $03 + $80 { test bit}             shl 8,
  $04 + (HorzRetrace div CharWidth) shl 8,
  $05 + (HorzStart   div CharWidth) shl 8,
  $06 + (VideoHeight and 255)       shl 8;
  $07 + (VertRetrace  shr 9)        shl 8;
      + (ScreenHeight shr 9)        shl 8;
      + (VideoHeight  shr 9)        shl 8;
      { 4=SplitLine }

  $09 + (



  $0D06,    { Vertical total            }
            { + Overflow (5,0) = 512    }
            { 512+13= 525 lines         }

  $3E07,    { Overflow 0011-1110        }

  $4109,    { Cell height  0100-0001    }
            { no line duplication       }
 {----------------------------------------}
  $EA10,    { V sync. start             }
            { + Overflow (7,2) = 256    }
            { 234+256 = Last Line 490   }
  $AC11,    { V sync. end/Prot CR0 CR7  }

  $DF12,    { Vertical displayed        }
            { + Overflow (6,1) = 768    }
            { 223+768 = 991             }
(*
  $4013,    { 2D offset                    } { 5A->180 40->128 }
            { 2*45 = 90 octets/line     }
*)
  $13 + (LineChars div 2) shl 8,

  $0014,    { DWord mode off            }
            { (offset *2)               }
  $E715,    { V Blank start             }
            { + overlow (3)             }
            { + CellHeight (6)          }
            { 231+512 = 743             }
  $0616,    { V Blank end               }
            { line 6 }
  $E317     { Turn on Byte mode         }
